unit sortip;

INTERFACE

type mutato=^sorelem;
     elemtip=string[63];
     sorelem=record
             ertek:elemtip;
             ido:integer;
             kov:mutato;
     end;
     sor=record
         eleje,vege:mutato;
         hiba:boolean;
     end;

var s:sor;

procedure ures(var s:sor);
function ures_e(const s:sor):boolean;
function tele_e:boolean;
function hibas_e(var s:sor):boolean;
procedure sorba(var s:sor; const e:elemtip);
procedure sorbol(var s:sor; var e:elemtip);
procedure ures_felszabadit(var s:sor);
procedure memki;

IMPLEMENTATION

procedure ures(var s:sor);

begin
     s.eleje:=nil;
     s.vege:=nil;
     s.hiba:=false;
end;

function ures_e(const s:sor):boolean;

begin
     ures_e:=(s.eleje=nil);
end;

function tele_e:boolean;

begin
     tele_e:=MaxAvail<SizeOf(sorelem);
end;

function hibas_e(var s:sor):boolean;

begin
     hibas_e:=s.hiba;
     s.hiba:=false;
end;

procedure sorba(var s:sor; const e:elemtip);
var uj:mutato;

begin
     if tele_e then s.hiba:=true
               else
                   begin
                        new(uj);
                        uj^.ertek:=e;
                        uj^.kov:=nil;
                        if (s.eleje=nil) then s.eleje:=uj
                                         else (s.vege)^.kov:=uj;
                        s.vege:=uj;
                   end;
end;

procedure sorbol(var s:sor; var e:elemtip);
var sv:mutato;

begin
     if ures_e(s) then s.hiba:=true
                  else
                      begin
                           e:=(s.eleje)^.ertek;
                           sv:=s.eleje;
                           s.eleje:=(s.eleje)^.kov;
                           dispose(sv);
                      end;
end;

procedure ures_felszabadit(var s:sor);
var sv:mutato;

begin
     if ures_e(s) then
                      begin
                           s.hiba:=false;
                           s.vege:=nil;
                      end
                  else
                      begin
                           while s.eleje<>nil do
                                 begin
                                      sv:=s.eleje;
                                      s.eleje:=(s.eleje)^.kov;
                                      dispose(sv);
                                 end;
                           s.hiba:=false;
                           s.vege:=nil;
                      end;
end;

procedure memki;

begin
     writeln('A memria szabad terlete: ',MemAvail,' bjt');
     write('A legnagyobb szabad blokk: ',MaxAvail,' bjt');
end;

Begin
End.