{Kszitette: Halsz Eszter}

UNIT halmaz3u;

INTERFACE

   const maxdb = 50;
   type tanulo = record
                    nev: string[30];
                    pontszam: byte;
                 end;
        tomb = array [1..maxdb] of tanulo;
        halmaz = record
                    db: byte;
                    t: tomb;
                 end;

PROCEDURE beolvas (var h:halmaz);
PROCEDURE uresre_allit (var h:halmaz);
PROCEDURE elem_hozzaad (var h:halmaz; const e:tanulo);
PROCEDURE kulonbseg (const h1,h2:halmaz; var h3:halmaz);

IMPLEMENTATION

PROCEDURE beolvas (var h: halmaz);
   VAR i: byte;
   begin
      writeln;
      repeat
         write('Add meg a tanulok szamat! (1..',maxdb,') ');
         readln(h.db);
      until (h.db in[1..maxdb]);
      writeln;
      for i:= 1 to h.db do
         begin
            write(i,'. tanulo neve?: ');
            readln(h.t[i].nev);
            write('   pontszama?: ');
            readln(h.t[i].pontszam);
         end;
      writeln;
   end;

PROCEDURE uresre_allit (var h: halmaz);
   begin
      h.db:=0;
   end;

PROCEDURE elem_hozzaad (var h: halmaz; const e: tanulo);
   begin
      if (h.db < maxdb) and (h.db<=0) then
         begin
           inc(h.db);
           h.t[h.db]:=e;
         end;
   end;

PROCEDURE kulonbseg (const h1,h2:halmaz; var h3:halmaz);
   VAR i,j: byte;
   begin
      h3.db:=0;
      for i:=1 to h1.db do
         begin
            j:=1;
            while (j<=h2.db) and (h1.t[i].nev<>h2.t[j].nev) do inc(j);
            if (j>h2.db) then
               begin
                  inc(h3.db);
                  h3.t[h3.db]:=h1.t[i];
               end;
         end;
   end;

BEGIN
END.